/******************************************************************************
 ******************************************************************************
 
 Small program to create drive letters from existing directories.
 Useful to "emulate" CDs from existing directories.
 
 [Last modification: 2004-10-03]

                 ___
                /   |                     ||              ||
               / _  |   ________ ___  ____||__    ___   __||
              / /_\ |  / __/ __//   |/  _/|   \  /   | /   |
             / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET
            /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|
       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       [http://assarbad.info | http://assarbad.net | http://assarbad.org]

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 2004, -=Assarbad=-
 All rights reserved.

 This code is being released into the PUBLIC DOMAIN! You may use it without any
 mentioning of where it came from. But it would be nice though if you could
 mention me as the original developer - preferably with a link to my site.

                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************
 ******************************************************************************/

#define _X86_
#define WIN32_LEAN_AND_MEAN
#define _DLL
#define _MT
#define UNICODE

#include <windows.h>
#include <Shellapi.h>
#include <stdarg.h>
#include <Winuser.h>

#pragma warning(push, 4)
#pragma warning(disable:4244)
#pragma optimize("gsy",on)

#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"shell32.lib")

#if (_MSC_VER<1300)
  #pragma comment(linker,"/RELEASE")
#endif
#pragma comment(linker, "-opt:nowin98")
#pragma comment(linker, "-entry:Main")
#pragma comment(linker, "-opt:ref")
#pragma comment(linker, "-merge:.rdata=.text")
#pragma comment(linker, "-merge:.reloc=.text")
#pragma comment(linker, "-subsystem:console")
#pragma comment(linker,"-ignore:4078") // ignore warning about merged sections

#define alloc(x) (LPVOID)GlobalAlloc(GPTR, x)
#define free(x)  if(x) {GlobalFree((HGLOBAL)x); x = NULL;}

#define kB 0x400
#define COPYLEFT TEXT("SUBST4NT - (c) 2004 by -=Assarbad=-\nThis small program is released into the PUBLIC DOMAIN!\n\n")
#define USAGE_1  TEXT("Syntax:\n     %s <drive:> <path|-r>\n\n")
#define USAGE(x) printf(USAGE_1, x)
#define ERROR_EXIT(x) {printf(TEXT("Error: "), x); USAGE(exe); return;}

HANDLE hConsole = 0;

/* For console string output; max length = 1024 / sizeof(TCHAR) */
void printf(LPCTSTR lpString, ...)
{
// Just a DWORD
  DWORD dwNumberOfCharsWritten = 0;
// Buffer to be used to store the output string
  LPTSTR lpBuf = alloc(0x400 * sizeof(TCHAR));
// Declare va_list
  va_list marker;
// Check wether buffer was successfully allocated
  if(lpBuf)
  __try
  {
// Start va_list
    va_start(marker, lpString);
// Format the string
    wvsprintf(lpBuf, lpString, marker);
// Output
    WriteConsole(hConsole, lpBuf, lstrlen(lpBuf), &dwNumberOfCharsWritten, NULL);
  }
  __finally
  {
// Free the buffer
    free(lpBuf);
// End va_list
    va_end(marker);
  }
}

/* Entry point */
void __cdecl Main()
{
  int argc;
  LPTSTR* argv = CommandLineToArgvW(GetCommandLine(), &argc);
  LPTSTR exe = *argv; // Save EXE name in this variable
  LPTSTR lpDrive = NULL, lpPath = NULL, lpTemp = NULL;
  DWORD dwDefDosDevFlag = 0;
// Get STDOUT handle
  hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
// Copyleft
  printf(COPYLEFT);
// Syntax hint
  if (argc != 3)
    ERROR_EXIT(TEXT("Wrong Syntax!\n"));
// Go through all parameters
  while(argc > 1)
  {
// Take next parameter (jumps over first)
    LPTSTR arg = *(++argv); --argc;
    if (arg[0] >= 'a') arg[0] -= 0x20; // Make uppercase
// Allocate buffer
    if (!(lpPath = alloc(4 * kB * sizeof(TCHAR))))
      ERROR_EXIT(TEXT("Not enough memory!\n"));
// Check first parameter
    if((lstrlen(arg) == 2) && ('A' <= arg[0] <= 'Z') && (arg[1] == ':'))
    {
      lpDrive = arg; // Save the drive letter in a variable
      arg = *(++argv); --argc; // Next parameter
// Check second parameter
      if(lstrcmpi(TEXT("-r"), arg) == 0)
// Set the flag for removal
        dwDefDosDevFlag = DDD_REMOVE_DEFINITION;
      else
// Allocate buffer
      {
// Set flag for object path
        dwDefDosDevFlag = DDD_RAW_TARGET_PATH;
// Prepend path with respective prefix
        lstrcpy(lpPath, TEXT("\\??\\"));
        lstrcat(lpPath, arg);
      }
// Output text according to action type
      if (dwDefDosDevFlag == DDD_REMOVE_DEFINITION)
        arg = TEXT("removed");
      else
        arg = TEXT("created");
// Do the job
      if (DefineDosDevice(dwDefDosDevFlag, lpDrive, (dwDefDosDevFlag == DDD_REMOVE_DEFINITION) ? NULL : lpPath))
        lpTemp = TEXT("was successfully");
      else
        lpTemp = TEXT("failed to be");
// Output of result
      printf(TEXT("The drive letter %s %s %s.\n\n"), lpDrive, lpTemp ,arg);
// Query current drive mappping for the given drive letter
      ZeroMemory(lpPath, 4 * kB * sizeof(TCHAR));
      QueryDosDevice(lpDrive, lpPath, 4 * kB);
// Output
      printf(TEXT("Current mapping is:\n    %s <-> %s\n\n"), lpDrive, (lstrlen(lpPath)) ? lpPath : TEXT("<none>") );
      free(lpPath);
      return;
    }
    else
      ERROR_EXIT(TEXT("Invalid drive letter syntax!\n"));
  }
}

